/*
 ============================================================================
 Name        : test.c
 Author      : LiYongjun
 Version     : 1.0
 Copyright   : Your copyright notice
 Description : Hello World in C, Ansi-style
 ============================================================================
 */
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <errno.h>
#include <pthread.h>

#define RET_OK 0
#define RET_ERR -1

#define LISTEN_QUEUE_NUM 5

#define BUFFER_SIZE 256

// #define ECHO_PORT 35595

int sockfd;
int sockfd2;
struct sockaddr_in servaddr;

void *loop_thread(void *arg)
{
    int ret = RET_OK;
    char buffer[100] = "Anosi_search";
    while (1)
    {
        if ((ret = sendto(sockfd, buffer, strlen(buffer), 0, (struct sockaddr *)&servaddr, sizeof(servaddr))) < 0)
        {
            perror("ERROR writing to socket");
            // break;
        }
        sleep(2);
    }
}

int main(int argc, char **argv)
{
    int ret = RET_OK;
    struct sockaddr_in recvaddr;
    struct sockaddr_in cliaddr;
    struct hostent *server;
    char buffer[BUFFER_SIZE];
    char *chat;
    int port;
    if (argc < 3)
    {
        fprintf(stderr, "usage %s hostname\n", argv[0]);
        return RET_ERR;
    }

    if ((server = gethostbyname(argv[1])) == NULL)
    {
        herror(" gethostbyname.");
        return RET_ERR;
    }

    if ((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) < 0)
    {
        herror("ERROR opening socket");
        return RET_ERR;
    }


    if ((sockfd2 = socket(AF_INET, SOCK_DGRAM, 0)) < 0)
    {
        herror("ERROR opening socket");
        return RET_ERR;
    }
    struct sockaddr_in sevaddr;
    memset(&sevaddr, 0, sizeof(sevaddr));
    sevaddr.sin_family = AF_INET;
    sevaddr.sin_addr.s_addr = htonl(INADDR_ANY);
    sevaddr.sin_port = htons(39556);

    if ((ret = bind(sockfd2, (struct sockaddr *)&sevaddr, sizeof(sevaddr))) < 0)
    {
        perror("ERROR on binding");
        // goto failed;
        return -1;
    }
    else
    {
        printf("bind ok\n");
    }
    

    port = atoi(argv[2]);
    const int opt = 1;
    ret = setsockopt(sockfd, SOL_SOCKET, SO_BROADCAST, (char *)&opt, sizeof(opt));
    if (ret == -1)
        printf("Set sock to broadcast format fail\n");

    memset(&servaddr, 0, sizeof(servaddr)); //申请信息表空间

    servaddr.sin_family = AF_INET;                          //设为IPv4
    servaddr.sin_addr.s_addr = *(uint32_t *)server->h_addr; //地址转换,32位大端字序
    servaddr.sin_port = htons((uint16_t)port);              //设定端口,16位大端字序转换

    int maxfd, nfound;
    fd_set set, rset;
    maxfd = fileno(stdin); /*将键盘转换成一种需要的类型*/
    FD_ZERO(&set);
    FD_SET(sockfd, &set); /*网络*/
    FD_SET(sockfd2, &set); /*网络*/
    FD_SET(maxfd, &set);  /*键盘*/
    printf("sockfd = %d\n", sockfd);
    printf("sockfd2 = %d\n", sockfd2);
    printf("maxfd = %d\n", maxfd);
    maxfd = (maxfd > sockfd2 ? maxfd : sockfd2) + 1;
    printf("maxfd = %d\n", maxfd);

    pthread_t loop_thread_t;
    if (pthread_create(&loop_thread_t, NULL, loop_thread, NULL) == 0)
    {
        printf("loop thread create success\n");
    }
    else
    {
        printf("loop thread create error\n");
        exit(1);
    }

    while (1)
    {
        rset = set;
        if ((nfound = select(maxfd, &rset, (fd_set *)0, (fd_set *)0, NULL)) < 0)
        {
            if (errno == EINTR)
            {
                fprintf(stderr, "interrupted system call\n");
                continue;
            }
            perror("select");
            exit(1);
        }
        if (FD_ISSET(fileno(stdin), &rset))
        {
            printf("Enter the message : ");
            if (fgets(buffer, sizeof(buffer) - 1, stdin) == NULL) /* fgets ()本身是一个阻塞型函数，但能执行到这条语句的前提条件是键盘有动作，所以放在这里的 fgets()函数并不会阻塞*/
                break;
            if (strstr(buffer, ":") == NULL && strstr(buffer, "@") == NULL)
            {
                if ((ret = sendto(sockfd, buffer, strlen(buffer), 0, (struct sockaddr *)&servaddr, sizeof(servaddr))) < 0)
                {
                    perror("ERROR writing to socket");
                    break;
                }
            }
            else
            {
                memset(&cliaddr, 0, sizeof(servaddr)); //申请信息表空间
                cliaddr.sin_family = AF_INET;          //设为IPv4
                cliaddr.sin_addr.s_addr = inet_addr(strtok(buffer, ":@"));
                cliaddr.sin_port = htons(atoi(strtok(NULL, ":@"))); //设定端口,16位大端字序转换
                chat = strtok(NULL, ":@");
                if ((ret = sendto(sockfd, chat, strlen(chat), 0, (struct sockaddr *)&cliaddr, sizeof(cliaddr))) < 0)
                {
                    perror(" sendto");
                }
            }
        }
        if (FD_ISSET(sockfd, &rset))
        {
            uint32_t len = sizeof(recvaddr);

            if ((ret = recvfrom(sockfd, buffer, sizeof(buffer) - 1, 0, (struct sockaddr *)&recvaddr, &len)) < 0)
            {
                perror("ERROR reading from socket");
                break;
            }
            buffer[ret] = 0;
            // printf("Server echo message: %s\n", buffer);
            printf("[%s:%d]%s\n", inet_ntoa(recvaddr.sin_addr), ntohs(recvaddr.sin_port), buffer);
        }
        if (FD_ISSET(sockfd2, &rset))
        {
            uint32_t len = sizeof(recvaddr);

            if ((ret = recvfrom(sockfd2, buffer, sizeof(buffer) - 1, 0, (struct sockaddr *)&recvaddr, &len)) < 0)
            {
                perror("ERROR reading from socket");
                break;
            }
            buffer[ret] = 0;
            // printf("Server echo message: %s\n", buffer);
            printf("[%s:%d]%s\n", inet_ntoa(recvaddr.sin_addr), ntohs(recvaddr.sin_port), buffer);
        }
    }
    close(sockfd);
    return ret < 0 ? RET_ERR : RET_OK;
}
